/* From: kenter@cs.utwente.nl (Arjan Kenter)

Here's some code I wrote some time ago, it accepts *, ? and [] wild
cards. The code does not check if what is put between [] actually
makes sense, it's easy to add though. A valid call could be
eg. ``match ("a*b?c[A-Za-z_0-9]d*", astring)''
*/

#include <string.h>

int inrange (char **pat, char ch) {
  int in = 0;
  char l='-', r;

  do {
    if ((r = *(*pat)++) == '-') {
      r = *(*pat)++;
      if (l <= ch && ch <= r) in = 1;
    }
    else {
      if (ch == (l = r))
	in = 1;
    }
  }
  while (**pat != ']');
  return in;
}

int match(char *pat, char *str) {
  if (!*str) {
    if (*pat == '*')
      return match (pat+1, str);
    else
      return !*pat;
  }
  switch (*pat) {
  case '\0': return !*str;
  case '*' :
    if (match (pat+1, str))
      return 1;
    return match (pat, str+1);
  case '?' : return match (pat+1, str+1);
  case '[' : return inrange (&pat, *str) && match (pat+1, str+1);
  default  : return *pat == *str && match (pat+1, str+1);
  }
}
